# Edited by rpmlb
%{?scl:%scl_package perl-Params-ValidationCompiler}

# Run optional test
%bcond_without perl_Params_ValidationCompiler_enables_optional_test

Name:		%{?scl_prefix}perl-Params-ValidationCompiler
Version:	0.26
Release:	2%{?dist}
Summary:	Build an optimized subroutine parameter validator once, use it forever
License:	Artistic 2.0
URL:		http://search.cpan.org/dist/Params-ValidationCompiler/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/Params-ValidationCompiler-%{version}.tar.gz
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	make
BuildRequires:	%{?scl_prefix}perl-generators
BuildRequires:	%{?scl_prefix}perl-interpreter
BuildRequires:	%{?scl_prefix}perl(ExtUtils::MakeMaker) > 6.75
# Module
BuildRequires:	%{?scl_prefix}perl(B)
BuildRequires:	%{?scl_prefix}perl(Carp)
BuildRequires:	%{?scl_prefix}perl(Eval::Closure)
BuildRequires:	%{?scl_prefix}perl(Exception::Class)
BuildRequires:	%{?scl_prefix}perl(Exporter)
BuildRequires:	%{?scl_prefix}perl(List::Util) >= 1.29
BuildRequires:	%{?scl_prefix}perl(overload)
BuildRequires:	%{?scl_prefix}perl(Scalar::Util)
BuildRequires:	%{?scl_prefix}perl(strict)
BuildRequires:	%{?scl_prefix}perl(warnings)
# Optional Functionality
BuildRequires:	%{?scl_prefix}perl(Sub::Util) >= 1.40
# Test Suite
BuildRequires:	%{?scl_prefix}perl(File::Spec)
BuildRequires:	%{?scl_prefix}perl(Specio) >= 0.14
BuildRequires:	%{?scl_prefix}perl(Specio::Declare)
BuildRequires:	%{?scl_prefix}perl(Specio::Library::Builtins)
BuildRequires:	%{?scl_prefix}perl(Test2::Plugin::NoWarnings)
BuildRequires:	%{?scl_prefix}perl(Test2::Require::Module)
BuildRequires:	%{?scl_prefix}perl(Test2::V0)
BuildRequires:	%{?scl_prefix}perl(Test::More) >= 1.302015
BuildRequires:	%{?scl_prefix}perl(Test::Without::Module)
%if %{with perl_Params_ValidationCompiler_enables_optional_test}
# Optional Tests
BuildRequires:	%{?scl_prefix}perl(Const::Fast)
BuildRequires:	%{?scl_prefix}perl(CPAN::Meta) >= 2.120900
BuildRequires:	%{?scl_prefix}perl(CPAN::Meta::Prereqs)
BuildRequires:	%{?scl_prefix}perl(Hash::Util)
%if !%{defined perl_bootstrap}
# Avoid build dependency cycles via Moose and DateTime
BuildRequires:	%{?scl_prefix}perl(Moose::Util::TypeConstraints)
BuildRequires:	%{?scl_prefix}perl(Types::Standard)
%endif
%endif
# Dependencies
Requires:	%{?scl_prefix}perl(:MODULE_COMPAT_%(%{?scl:scl enable %{scl} '}eval "$(perl -V:version)";echo $version%{?scl:'}))
Requires:	%{?scl_prefix}perl(Sub::Util) >= 1.40

%description
Create a customized, optimized, non-lobotomized, uncompromised, and thoroughly
specialized parameter checking subroutine.

%prep
%setup -q -n Params-ValidationCompiler-%{version}

%build
%{?scl:scl enable %{scl} '}perl Makefile.PL INSTALLDIRS=vendor NO_PERLLOCAL=1 NO_PACKLIST=1 && make %{?_smp_mflags}%{?scl:'}

%install
%{?scl:scl enable %{scl} '}make install DESTDIR=%{buildroot}%{?scl:'}
%{_fixperms} -c %{buildroot}

%check
%{?scl:scl enable %{scl} '}make test%{?scl:'}

%files
%doc LICENSE
%doc Changes eg/ README.md
%{perl_vendorlib}/Params/
%{_mandir}/man3/Params::ValidationCompiler.3*
%{_mandir}/man3/Params::ValidationCompiler::Compiler.3*
%{_mandir}/man3/Params::ValidationCompiler::Exceptions.3*

%changelog
* Tue Dec 19 2017 Petr Pisar <ppisar@redhat.com> - 0.26-2
- SCL

* Tue Nov 28 2017 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - The exceptions.t test would fail if Sub::Util was not installed (GH#19)
  - Fix test failures on Windows (GH#20)

* Fri Nov 24 2017 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25
  - All exceptions now include a stack trace by default when treated as a
    string; this makes finding where validation failed a lot easier (GH#18)
  - The name for a subroutine is now used in some exception messages, even if
    Sub::Util cannot be installed

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.24-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Jun 07 2017 Jitka Plesnikova <jplesnik@redhat.com> - 0.24-3
- Perl 5.26 re-rebuild of bootstrapped packages

* Mon Jun 05 2017 Jitka Plesnikova <jplesnik@redhat.com> - 0.24-2
- Perl 5.26 rebuild

* Sun Apr  9 2017 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
  - The source_for() exported by Params::ValidationCompiler did not work at all
    (GH#16)

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Jan 23 2017 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Trying to create a validator for positional parameters where a required
    param came after one with a default did not throw an exception
  - A positional params validator with a slurpy type that had coercions did not
    return the coerced values; it returned the original values instead

* Sat Dec 31 2016 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22
  - Explicitly load the B module; previously, the code relied on this already
    being loaded by something else (GH#11)
  - Removed the alpha warning from the docs

* Wed Dec  7 2016 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Switched to using GitHub issues

* Tue Dec  6 2016 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - The keys for parameter specifications are now validated, and if an unknown
    key is seen then an exception will be thrown; this will help you catch
    typos in your parameter specification (GH#8)

* Tue Nov 22 2016 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - Non-inlinable Specio types caused a syntax error when used with positional
    params
  - Positional params with coercions and defaults did not work properly; the
    coerced value and the default would simply not be returned in any case

* Mon Nov 14 2016 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18
  - Using coercions with positional parameters could cause a "Modification of a
    read-only value attempted" exception when the generated code tried to
    assign to elements of @_; this is now fixed by making a copy if any of the
    types have a coercion
  - Using Moose types with coercions in a positional params check would cause
    invalid code to be generated; this could also happen with Type::Tiny if
    either the type or a coercion could not be inlined

* Mon Nov  7 2016 Paul Howarth <paul@city-fan.org> - 0.17-1
- Update to 0.17
  - When using positional parameters, parameters with a default are now
    optional; for named parameters, this was already the case

* Fri Nov  4 2016 Paul Howarth <paul@city-fan.org> - 0.16-1
- Update to 0.16
  - Previously, using a default with a positional parameter would result in an
    error when compiling the validator subroutine; defaults now work with
    positional parameters (GH#5)
  - Moose and Specio types (and coercions) that provide variables to close over
    when being inlined did not always compile properly; most notably, this was
    not being handled at all for Moose types, and not completely handled for
    Specio coercions

* Thu Nov  3 2016 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Added a "named_to_list" option to support returning only the parameter
    values from a named parameter validator rather than the key-value pairs
    (GH#4)
  - Errors from calls to validation_for() now use croak so as to show up at the
    call site, rather than in the internals

* Wed Oct 26 2016 Petr Pisar <ppisar@redhat.com> - 0.13-4
- Break build cycle: perl-Moose → perl-DateTime → perl-Params-ValidationCompiler

* Mon Sep 19 2016 Paul Howarth <paul@city-fan.org> - 0.13-3
- Drop unused BR: findutils (#1377252)

* Mon Sep 19 2016 Paul Howarth <paul@city-fan.org> - 0.13-2
- Sanitize for Fedora submission

* Sun Sep 18 2016 Paul Howarth <paul@city-fan.org> - 0.13-1
- Initial RPM version
